﻿using SimpleWebScraper.Data;
using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace SimpleWebScraper.Workers
{
    class Scraper
    {
        public List<string> Scrape(ScrapeCriteria scrapeCriteria)
        {
            List<string> scrapedElements = new List<string>();

            MatchCollection matches = Regex.Matches(scrapeCriteria.Data, scrapeCriteria.Regex, scrapeCriteria.RegexOption);

            foreach(Match match in matches)
            {
                if (scrapeCriteria.Parts.Count.Equals(0))
                {
                    // there are no parts to check, results are final
                    scrapedElements.Add(match.Groups[0].Value);
                } else
                {
                    // Some parts to distill, so let's find'em
                    foreach (ScrapeCriteriaPart part in scrapeCriteria.Parts)
                    {
                        Match matchedPart = Regex.Match(match.Groups[0].Value, part.Regex, part.RegexOption);

                        if (matchedPart.Success)
                        {
                            scrapedElements.Add(matchedPart.Groups[1].Value);
                        }
                    }
                }
            }

            return scrapedElements;
        }
    }
}
